#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - channel configuration y register"]
    pub ch0cfgr1: CH0CFGR1,
    #[doc = "0x04 - channel configuration y register"]
    pub ch0cfgr2: CH0CFGR2,
    #[doc = "0x08 - analog watchdog and short-circuit detector register"]
    pub ch0awscdr: CH0AWSCDR,
    #[doc = "0x0c - channel watchdog filter data register"]
    pub ch0wdatr: CH0WDATR,
    #[doc = "0x10 - channel data input register"]
    pub ch0datinr: CH0DATINR,
    _reserved0: [u8; 12usize],
    #[doc = "0x20 - CHCFG1R1"]
    pub ch1cfgr1: CH1CFGR1,
    #[doc = "0x24 - CHCFG1R2"]
    pub ch1cfgr2: CH1CFGR2,
    #[doc = "0x28 - AWSCD1R"]
    pub ch1awscdr: CH1AWSCDR,
    #[doc = "0x2c - CHWDAT1R"]
    pub ch1wdatr: CH1WDATR,
    #[doc = "0x30 - CHDATIN1R"]
    pub ch1datinr: CH1DATINR,
    _reserved1: [u8; 12usize],
    #[doc = "0x40 - CHCFG2R1"]
    pub ch2cfgr1: CH2CFGR1,
    #[doc = "0x44 - CHCFG2R2"]
    pub ch2cfgr2: CH2CFGR2,
    #[doc = "0x48 - AWSCD2R"]
    pub ch2awscdr: CH2AWSCDR,
    #[doc = "0x4c - CHWDAT2R"]
    pub ch2wdatr: CH2WDATR,
    #[doc = "0x50 - CHDATIN2R"]
    pub ch2datinr: CH2DATINR,
    _reserved2: [u8; 12usize],
    #[doc = "0x60 - CHCFG3R1"]
    pub ch3cfgr1: CH3CFGR1,
    #[doc = "0x64 - CHCFG3R2"]
    pub ch3cfgr2: CH3CFGR2,
    #[doc = "0x68 - AWSCD3R"]
    pub ch3awscdr: CH3AWSCDR,
    #[doc = "0x6c - CHWDAT3R"]
    pub ch3wdatr: CH3WDATR,
    #[doc = "0x70 - CHDATIN3R"]
    pub ch3datinr: CH3DATINR,
    _reserved3: [u8; 12usize],
    #[doc = "0x80 - CHCFG4R1"]
    pub ch4cfgr1: CH4CFGR1,
    #[doc = "0x84 - CHCFG4R2"]
    pub ch4cfgr2: CH4CFGR2,
    #[doc = "0x88 - AWSCD4R"]
    pub ch4awscdr: CH4AWSCDR,
    #[doc = "0x8c - CHWDAT4R"]
    pub ch4wdatr: CH4WDATR,
    #[doc = "0x90 - CHDATIN4R"]
    pub ch4datinr: CH4DATINR,
    _reserved4: [u8; 12usize],
    #[doc = "0xa0 - CHCFG5R1"]
    pub ch5cfgr1: CH5CFGR1,
    #[doc = "0xa4 - CHCFG5R2"]
    pub ch5cfgr2: CH5CFGR2,
    #[doc = "0xa8 - AWSCD5R"]
    pub ch5awscdr: CH5AWSCDR,
    #[doc = "0xac - CHWDAT5R"]
    pub ch5wdatr: CH5WDATR,
    #[doc = "0xb0 - CHDATIN5R"]
    pub ch5datinr: CH5DATINR,
    _reserved5: [u8; 12usize],
    #[doc = "0xc0 - CHCFG6R1"]
    pub ch6cfgr1: CH6CFGR1,
    #[doc = "0xc4 - CHCFG6R2"]
    pub ch6cfgr2: CH6CFGR2,
    #[doc = "0xc8 - AWSCD6R"]
    pub ch6awscdr: CH6AWSCDR,
    #[doc = "0xcc - CHWDAT6R"]
    pub ch6wdatr: CH6WDATR,
    #[doc = "0xd0 - CHDATIN6R"]
    pub ch6datinr: CH6DATINR,
    _reserved6: [u8; 12usize],
    #[doc = "0xe0 - CHCFG7R1"]
    pub ch7cfgr1: CH7CFGR1,
    #[doc = "0xe4 - CHCFG7R2"]
    pub ch7cfgr2: CH7CFGR2,
    #[doc = "0xe8 - AWSCD7R"]
    pub ch7awscdr: CH7AWSCDR,
    #[doc = "0xec - CHWDAT7R"]
    pub ch7wdatr: CH7WDATR,
    #[doc = "0xf0 - CHDATIN7R"]
    pub ch7datinr: CH7DATINR,
    _reserved7: [u8; 12usize],
    #[doc = "0x100 - control register 1"]
    pub flt0cr1: FLT0CR1,
    #[doc = "0x104 - control register 2"]
    pub flt0cr2: FLT0CR2,
    #[doc = "0x108 - interrupt and status register"]
    pub flt0isr: FLT0ISR,
    #[doc = "0x10c - interrupt flag clear register"]
    pub flt0icr: FLT0ICR,
    #[doc = "0x110 - injected channel group selection register"]
    pub flt0jchgr: FLT0JCHGR,
    #[doc = "0x114 - filter control register"]
    pub flt0fcr: FLT0FCR,
    #[doc = "0x118 - data register for injected group"]
    pub flt0jdatar: FLT0JDATAR,
    #[doc = "0x11c - data register for the regular channel"]
    pub flt0rdatar: FLT0RDATAR,
    #[doc = "0x120 - analog watchdog high threshold register"]
    pub flt0awhtr: FLT0AWHTR,
    #[doc = "0x124 - analog watchdog low threshold register"]
    pub flt0awltr: FLT0AWLTR,
    #[doc = "0x128 - analog watchdog status register"]
    pub flt0awsr: FLT0AWSR,
    #[doc = "0x12c - analog watchdog clear flag register"]
    pub flt0awcfr: FLT0AWCFR,
    #[doc = "0x130 - Extremes detector maximum register"]
    pub flt0exmax: FLT0EXMAX,
    #[doc = "0x134 - Extremes detector minimum register"]
    pub flt0exmin: FLT0EXMIN,
    #[doc = "0x138 - conversion timer register"]
    pub flt0cnvtimr: FLT0CNVTIMR,
    _reserved8: [u8; 68usize],
    #[doc = "0x180 - control register 1"]
    pub flt1cr1: FLT1CR1,
    #[doc = "0x184 - control register 2"]
    pub flt1cr2: FLT1CR2,
    #[doc = "0x188 - interrupt and status register"]
    pub flt1isr: FLT1ISR,
    #[doc = "0x18c - interrupt flag clear register"]
    pub flt1icr: FLT1ICR,
    #[doc = "0x190 - injected channel group selection register"]
    pub flt1jchgr: FLT1JCHGR,
    #[doc = "0x194 - filter control register"]
    pub flt1fcr: FLT1FCR,
    #[doc = "0x198 - data register for injected group"]
    pub flt1jdatar: FLT1JDATAR,
    #[doc = "0x19c - data register for the regular channel"]
    pub flt1rdatar: FLT1RDATAR,
    #[doc = "0x1a0 - analog watchdog high threshold register"]
    pub flt1awhtr: FLT1AWHTR,
    #[doc = "0x1a4 - analog watchdog low threshold register"]
    pub flt1awltr: FLT1AWLTR,
    #[doc = "0x1a8 - analog watchdog status register"]
    pub flt1awsr: FLT1AWSR,
    #[doc = "0x1ac - analog watchdog clear flag register"]
    pub flt1awcfr: FLT1AWCFR,
    #[doc = "0x1b0 - Extremes detector maximum register"]
    pub flt1exmax: FLT1EXMAX,
    #[doc = "0x1b4 - Extremes detector minimum register"]
    pub flt1exmin: FLT1EXMIN,
    #[doc = "0x1b8 - conversion timer register"]
    pub flt1cnvtimr: FLT1CNVTIMR,
    _reserved9: [u8; 68usize],
    #[doc = "0x200 - control register 1"]
    pub flt2cr1: FLT2CR1,
    #[doc = "0x204 - control register 2"]
    pub flt2cr2: FLT2CR2,
    #[doc = "0x208 - interrupt and status register"]
    pub flt2isr: FLT2ISR,
    #[doc = "0x20c - interrupt flag clear register"]
    pub flt2icr: FLT2ICR,
    #[doc = "0x210 - injected channel group selection register"]
    pub flt2jchgr: FLT2JCHGR,
    #[doc = "0x214 - filter control register"]
    pub flt2fcr: FLT2FCR,
    #[doc = "0x218 - data register for injected group"]
    pub flt2jdatar: FLT2JDATAR,
    #[doc = "0x21c - data register for the regular channel"]
    pub flt2rdatar: FLT2RDATAR,
    #[doc = "0x220 - analog watchdog high threshold register"]
    pub flt2awhtr: FLT2AWHTR,
    #[doc = "0x224 - analog watchdog low threshold register"]
    pub flt2awltr: FLT2AWLTR,
    #[doc = "0x228 - analog watchdog status register"]
    pub flt2awsr: FLT2AWSR,
    #[doc = "0x22c - analog watchdog clear flag register"]
    pub flt2awcfr: FLT2AWCFR,
    #[doc = "0x230 - Extremes detector maximum register"]
    pub flt2exmax: FLT2EXMAX,
    #[doc = "0x234 - Extremes detector minimum register"]
    pub flt2exmin: FLT2EXMIN,
    #[doc = "0x238 - conversion timer register"]
    pub flt2cnvtimr: FLT2CNVTIMR,
    _reserved10: [u8; 68usize],
    #[doc = "0x280 - control register 1"]
    pub flt3cr1: FLT3CR1,
    #[doc = "0x284 - control register 2"]
    pub flt3cr2: FLT3CR2,
    #[doc = "0x288 - interrupt and status register"]
    pub flt3isr: FLT3ISR,
    #[doc = "0x28c - interrupt flag clear register"]
    pub flt3icr: FLT3ICR,
    #[doc = "0x290 - injected channel group selection register"]
    pub flt3jchgr: FLT3JCHGR,
    #[doc = "0x294 - filter control register"]
    pub flt3fcr: FLT3FCR,
    #[doc = "0x298 - data register for injected group"]
    pub flt3jdatar: FLT3JDATAR,
    #[doc = "0x29c - data register for the regular channel"]
    pub flt3rdatar: FLT3RDATAR,
    #[doc = "0x2a0 - analog watchdog high threshold register"]
    pub flt3awhtr: FLT3AWHTR,
    #[doc = "0x2a4 - analog watchdog low threshold register"]
    pub flt3awltr: FLT3AWLTR,
    #[doc = "0x2a8 - analog watchdog status register"]
    pub flt3awsr: FLT3AWSR,
    #[doc = "0x2ac - analog watchdog clear flag register"]
    pub flt3awcfr: FLT3AWCFR,
    #[doc = "0x2b0 - Extremes detector maximum register"]
    pub flt3exmax: FLT3EXMAX,
    #[doc = "0x2b4 - Extremes detector minimum register"]
    pub flt3exmin: FLT3EXMIN,
    #[doc = "0x2b8 - conversion timer register"]
    pub flt3cnvtimr: FLT3CNVTIMR,
}
#[doc = "channel configuration y register"]
pub struct CH0CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "channel configuration y register"]
pub mod ch0cfgr1;
#[doc = "channel configuration y register"]
pub struct CH0CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "channel configuration y register"]
pub mod ch0cfgr2;
#[doc = "analog watchdog and short-circuit detector register"]
pub struct CH0AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog and short-circuit detector register"]
pub mod ch0awscdr;
#[doc = "channel watchdog filter data register"]
pub struct CH0WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "channel watchdog filter data register"]
pub mod ch0wdatr;
#[doc = "channel data input register"]
pub struct CH0DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "channel data input register"]
pub mod ch0datinr;
#[doc = "CHCFG1R1"]
pub struct CH1CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG1R1"]
pub mod ch1cfgr1;
#[doc = "CHCFG1R2"]
pub struct CH1CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG1R2"]
pub mod ch1cfgr2;
#[doc = "AWSCD1R"]
pub struct CH1AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "AWSCD1R"]
pub mod ch1awscdr;
#[doc = "CHWDAT1R"]
pub struct CH1WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHWDAT1R"]
pub mod ch1wdatr;
#[doc = "CHDATIN1R"]
pub struct CH1DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHDATIN1R"]
pub mod ch1datinr;
#[doc = "CHCFG2R1"]
pub struct CH2CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG2R1"]
pub mod ch2cfgr1;
#[doc = "CHCFG2R2"]
pub struct CH2CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG2R2"]
pub mod ch2cfgr2;
#[doc = "AWSCD2R"]
pub struct CH2AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "AWSCD2R"]
pub mod ch2awscdr;
#[doc = "CHWDAT2R"]
pub struct CH2WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHWDAT2R"]
pub mod ch2wdatr;
#[doc = "CHDATIN2R"]
pub struct CH2DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHDATIN2R"]
pub mod ch2datinr;
#[doc = "CHCFG3R1"]
pub struct CH3CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG3R1"]
pub mod ch3cfgr1;
#[doc = "CHCFG3R2"]
pub struct CH3CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG3R2"]
pub mod ch3cfgr2;
#[doc = "AWSCD3R"]
pub struct CH3AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "AWSCD3R"]
pub mod ch3awscdr;
#[doc = "CHWDAT3R"]
pub struct CH3WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHWDAT3R"]
pub mod ch3wdatr;
#[doc = "CHDATIN3R"]
pub struct CH3DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHDATIN3R"]
pub mod ch3datinr;
#[doc = "CHCFG4R1"]
pub struct CH4CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG4R1"]
pub mod ch4cfgr1;
#[doc = "CHCFG4R2"]
pub struct CH4CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG4R2"]
pub mod ch4cfgr2;
#[doc = "AWSCD4R"]
pub struct CH4AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "AWSCD4R"]
pub mod ch4awscdr;
#[doc = "CHWDAT4R"]
pub struct CH4WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHWDAT4R"]
pub mod ch4wdatr;
#[doc = "CHDATIN4R"]
pub struct CH4DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHDATIN4R"]
pub mod ch4datinr;
#[doc = "CHCFG5R1"]
pub struct CH5CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG5R1"]
pub mod ch5cfgr1;
#[doc = "CHCFG5R2"]
pub struct CH5CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG5R2"]
pub mod ch5cfgr2;
#[doc = "AWSCD5R"]
pub struct CH5AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "AWSCD5R"]
pub mod ch5awscdr;
#[doc = "CHWDAT5R"]
pub struct CH5WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHWDAT5R"]
pub mod ch5wdatr;
#[doc = "CHDATIN5R"]
pub struct CH5DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHDATIN5R"]
pub mod ch5datinr;
#[doc = "CHCFG6R1"]
pub struct CH6CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG6R1"]
pub mod ch6cfgr1;
#[doc = "CHCFG6R2"]
pub struct CH6CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG6R2"]
pub mod ch6cfgr2;
#[doc = "AWSCD6R"]
pub struct CH6AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "AWSCD6R"]
pub mod ch6awscdr;
#[doc = "CHWDAT6R"]
pub struct CH6WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHWDAT6R"]
pub mod ch6wdatr;
#[doc = "CHDATIN6R"]
pub struct CH6DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHDATIN6R"]
pub mod ch6datinr;
#[doc = "CHCFG7R1"]
pub struct CH7CFGR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG7R1"]
pub mod ch7cfgr1;
#[doc = "CHCFG7R2"]
pub struct CH7CFGR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHCFG7R2"]
pub mod ch7cfgr2;
#[doc = "AWSCD7R"]
pub struct CH7AWSCDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "AWSCD7R"]
pub mod ch7awscdr;
#[doc = "CHWDAT7R"]
pub struct CH7WDATR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHWDAT7R"]
pub mod ch7wdatr;
#[doc = "CHDATIN7R"]
pub struct CH7DATINR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "CHDATIN7R"]
pub mod ch7datinr;
#[doc = "control register 1"]
pub struct FLT0CR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 1"]
pub mod flt0cr1;
#[doc = "control register 2"]
pub struct FLT0CR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 2"]
pub mod flt0cr2;
#[doc = "interrupt and status register"]
pub struct FLT0ISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt and status register"]
pub mod flt0isr;
#[doc = "interrupt flag clear register"]
pub struct FLT0ICR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt flag clear register"]
pub mod flt0icr;
#[doc = "injected channel group selection register"]
pub struct FLT0JCHGR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "injected channel group selection register"]
pub mod flt0jchgr;
#[doc = "filter control register"]
pub struct FLT0FCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "filter control register"]
pub mod flt0fcr;
#[doc = "data register for injected group"]
pub struct FLT0JDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for injected group"]
pub mod flt0jdatar;
#[doc = "data register for the regular channel"]
pub struct FLT0RDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for the regular channel"]
pub mod flt0rdatar;
#[doc = "analog watchdog high threshold register"]
pub struct FLT0AWHTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog high threshold register"]
pub mod flt0awhtr;
#[doc = "analog watchdog low threshold register"]
pub struct FLT0AWLTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog low threshold register"]
pub mod flt0awltr;
#[doc = "analog watchdog status register"]
pub struct FLT0AWSR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog status register"]
pub mod flt0awsr;
#[doc = "analog watchdog clear flag register"]
pub struct FLT0AWCFR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog clear flag register"]
pub mod flt0awcfr;
#[doc = "Extremes detector maximum register"]
pub struct FLT0EXMAX {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector maximum register"]
pub mod flt0exmax;
#[doc = "Extremes detector minimum register"]
pub struct FLT0EXMIN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector minimum register"]
pub mod flt0exmin;
#[doc = "conversion timer register"]
pub struct FLT0CNVTIMR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "conversion timer register"]
pub mod flt0cnvtimr;
#[doc = "control register 1"]
pub struct FLT1CR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 1"]
pub mod flt1cr1;
#[doc = "control register 2"]
pub struct FLT1CR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 2"]
pub mod flt1cr2;
#[doc = "interrupt and status register"]
pub struct FLT1ISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt and status register"]
pub mod flt1isr;
#[doc = "interrupt flag clear register"]
pub struct FLT1ICR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt flag clear register"]
pub mod flt1icr;
#[doc = "injected channel group selection register"]
pub struct FLT1JCHGR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "injected channel group selection register"]
pub mod flt1jchgr;
#[doc = "filter control register"]
pub struct FLT1FCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "filter control register"]
pub mod flt1fcr;
#[doc = "data register for injected group"]
pub struct FLT1JDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for injected group"]
pub mod flt1jdatar;
#[doc = "data register for the regular channel"]
pub struct FLT1RDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for the regular channel"]
pub mod flt1rdatar;
#[doc = "analog watchdog high threshold register"]
pub struct FLT1AWHTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog high threshold register"]
pub mod flt1awhtr;
#[doc = "analog watchdog low threshold register"]
pub struct FLT1AWLTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog low threshold register"]
pub mod flt1awltr;
#[doc = "analog watchdog status register"]
pub struct FLT1AWSR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog status register"]
pub mod flt1awsr;
#[doc = "analog watchdog clear flag register"]
pub struct FLT1AWCFR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog clear flag register"]
pub mod flt1awcfr;
#[doc = "Extremes detector maximum register"]
pub struct FLT1EXMAX {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector maximum register"]
pub mod flt1exmax;
#[doc = "Extremes detector minimum register"]
pub struct FLT1EXMIN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector minimum register"]
pub mod flt1exmin;
#[doc = "conversion timer register"]
pub struct FLT1CNVTIMR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "conversion timer register"]
pub mod flt1cnvtimr;
#[doc = "control register 1"]
pub struct FLT2CR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 1"]
pub mod flt2cr1;
#[doc = "control register 2"]
pub struct FLT2CR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 2"]
pub mod flt2cr2;
#[doc = "interrupt and status register"]
pub struct FLT2ISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt and status register"]
pub mod flt2isr;
#[doc = "interrupt flag clear register"]
pub struct FLT2ICR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt flag clear register"]
pub mod flt2icr;
#[doc = "injected channel group selection register"]
pub struct FLT2JCHGR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "injected channel group selection register"]
pub mod flt2jchgr;
#[doc = "filter control register"]
pub struct FLT2FCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "filter control register"]
pub mod flt2fcr;
#[doc = "data register for injected group"]
pub struct FLT2JDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for injected group"]
pub mod flt2jdatar;
#[doc = "data register for the regular channel"]
pub struct FLT2RDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for the regular channel"]
pub mod flt2rdatar;
#[doc = "analog watchdog high threshold register"]
pub struct FLT2AWHTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog high threshold register"]
pub mod flt2awhtr;
#[doc = "analog watchdog low threshold register"]
pub struct FLT2AWLTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog low threshold register"]
pub mod flt2awltr;
#[doc = "analog watchdog status register"]
pub struct FLT2AWSR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog status register"]
pub mod flt2awsr;
#[doc = "analog watchdog clear flag register"]
pub struct FLT2AWCFR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog clear flag register"]
pub mod flt2awcfr;
#[doc = "Extremes detector maximum register"]
pub struct FLT2EXMAX {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector maximum register"]
pub mod flt2exmax;
#[doc = "Extremes detector minimum register"]
pub struct FLT2EXMIN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector minimum register"]
pub mod flt2exmin;
#[doc = "conversion timer register"]
pub struct FLT2CNVTIMR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "conversion timer register"]
pub mod flt2cnvtimr;
#[doc = "control register 1"]
pub struct FLT3CR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 1"]
pub mod flt3cr1;
#[doc = "control register 2"]
pub struct FLT3CR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 2"]
pub mod flt3cr2;
#[doc = "interrupt and status register"]
pub struct FLT3ISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt and status register"]
pub mod flt3isr;
#[doc = "interrupt flag clear register"]
pub struct FLT3ICR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt flag clear register"]
pub mod flt3icr;
#[doc = "injected channel group selection register"]
pub struct FLT3JCHGR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "injected channel group selection register"]
pub mod flt3jchgr;
#[doc = "filter control register"]
pub struct FLT3FCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "filter control register"]
pub mod flt3fcr;
#[doc = "data register for injected group"]
pub struct FLT3JDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for injected group"]
pub mod flt3jdatar;
#[doc = "data register for the regular channel"]
pub struct FLT3RDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for the regular channel"]
pub mod flt3rdatar;
#[doc = "analog watchdog high threshold register"]
pub struct FLT3AWHTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog high threshold register"]
pub mod flt3awhtr;
#[doc = "analog watchdog low threshold register"]
pub struct FLT3AWLTR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog low threshold register"]
pub mod flt3awltr;
#[doc = "analog watchdog status register"]
pub struct FLT3AWSR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog status register"]
pub mod flt3awsr;
#[doc = "analog watchdog clear flag register"]
pub struct FLT3AWCFR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "analog watchdog clear flag register"]
pub mod flt3awcfr;
#[doc = "Extremes detector maximum register"]
pub struct FLT3EXMAX {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector maximum register"]
pub mod flt3exmax;
#[doc = "Extremes detector minimum register"]
pub struct FLT3EXMIN {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "Extremes detector minimum register"]
pub mod flt3exmin;
#[doc = "conversion timer register"]
pub struct FLT3CNVTIMR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "conversion timer register"]
pub mod flt3cnvtimr;
